------------------------------------------------------------------
-- Mult by one digit and add cell
------------------------------------------------------------------
--
-- SO = SI + A*BBit
--

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity mult_by_1 is
  port (
    SI   : in  std_logic_vector(15 downto 0);  -- Signal input
    A    : in  std_logic_vector(15 downto 0);  -- Product term A
    BBit : in  std_logic;                      -- Product term B (bit)
    SO   : out std_logic_vector(16 downto 0)   -- Signal output
  );
end mult_by_1;


architecture Behavioral of mult_by_1 is
begin
  
  sum_mux : process(BBit, SI , A)
  begin
    if BBit = '1' then
      SO <= ('0' & SI) + ('0' & A);
    else
      SO <= ('0' & SI);
    end if;
  end process;

end Behavioral;
